# CSVFile Formatter

A Field formatter that renders CSV files uploaded to a Drupal File
field as a themable HTML table.

 * For a full description of the module, see the project page:
   https://www.drupal.org/project/csvfile_formatter

 * To submit bug reports, feature suggestions, or track changes:
   https://www.drupal.org/project/issues/csvfile_formatter

## Requirements

This module requires the following modules:

 * File field

## Installation

Install as you would normally install contributed Drupal modules.

The DataTables JS library may be loaded from the DataTables CDN.

If you would like to use the DataTables setting "Load from local files",
you will need to also install the DataTables libraries locally with Composer:

1. Run: `composer require mnsami/composer-custom-directory-installer`
2. Add the DataTables libraries, under `extra`, `installer-paths` in `composer.json`:
```
            "web/libraries/{$name}": [
                "datatables.net/datatables.net",
                "datatables.net/datatables.net-dt",
                "type:drupal-library"
            ],
```
3. Run: `composer require datatables.net/datatables.net-dt`

## Configuration

Create a Drupal File field on a content type.

On the "Manage Display" tab for the content type, select
"CSV File as Table" as the Format for the created File field.

Any properly formatted CSV file uploaded through the created
File field will be processed to generate an HTML table.

This field formatter includes options to provide a download
link for the original File, plus options to process the rows
and fields in the CSV file, and provide CSS classes for
components of the generated HTML table.

The field configuration setting "Smart URL handling" allows
https URLs, email addresses, and a limited form of Markdown
link syntax found in the CSV file to be rendered as links.
