/**
 * @file
 * CSV File Formatter behaviors.
 */

(function ($, Drupal) {
  /**
   * Adds DataTable to tables with the class '.add-externaljs-csvfiletable'.
   */
  Drupal.behaviors.csvfileFormatter = {
    attach(context, settings) {
      const dataTableSettings = drupalSettings.csvFormatter.dataTable;

      const elements = once(
        'csvfiletable-once',
        jQuery('.add-externaljs-csvfiletable'),
        context,
      );
      elements.forEach((element) => {
        const dataTableSetting = { ...dataTableSettings[0] };
        const numColumns = jQuery(element).find('th').length;

        const scrollXMin = dataTableSetting.scrollX;
        if (scrollXMin >= 0 && numColumns >= scrollXMin) {
          dataTableSetting.scrollX = true;
        } else {
          dataTableSetting.scrollX = false;
        }

        if (dataTableSetting.scrollY < 0) {
          delete dataTableSetting.scrollY;
        }

        jQuery(element).DataTable(dataTableSetting);
      });
    },
  };
})(jQuery, Drupal);
